import { IKey, IObj, IOption } from "../../type";
interface ClearEmptyValOption {
    clearEmptyStr?: boolean;
    clearSpace?: boolean;
}
declare const _default: {
    bfsTree: <T = any>(tree: T[], cb: (item: T) => boolean | void, options?: import("./TreeUtil").BFSOptions) => void;
    dfsTree: <T_1 = any>(tree: T_1[], cb: (item: T_1) => boolean | void, options?: import("./TreeUtil").DFSOptions) => void;
    TreeTransform: {
        pid2children<T_2 = IObj<any>>(data: T_2[], options?: import("./TreeUtil").TreeTransformOptions): T_2[];
        children2pid<T_3 = IObj<any>>(data: T_3[], options?: import("./TreeUtil").TreeTransformOptions): any[];
    };
    addCacheWrapper: <T_4 extends (...rest: any[]) => any>(func: T_4) => T_4;
    abortablePromise: <T_5>(promise: Promise<T_5>) => {
        promise: Promise<T_5>;
        abortController: AbortController;
    };
    genSetRefObjFunc: <T_6 extends IObj<any>>(obj: {
        current: T_6;
    }) => <K extends keyof T_6>(key: K | Partial<T_6> | ((v: T_6) => T_6), value?: T_6[K] | undefined) => void;
    genSetObjFunc: <T_7 extends IObj<any>>(obj: T_7) => <K_1 extends keyof T_7>(key: K_1 | Partial<T_7> | ((v: T_7) => void), value?: T_7[K_1] | undefined) => void;
    parseJson: <T_8 = any>(json: string) => T_8 | null;
    getDom: (id: string, className?: string | undefined) => HTMLDivElement;
    clearEmptyVal: <T_9 extends {} = IObj<any>>(obj: T_9, option?: ClearEmptyValOption) => T_9;
    toOptions: {
        arr2options<T_10 extends IKey>(arr: T_10[]): IOption<T_10, T_10>[];
        enum2options(e: Record<IKey, IKey>): {
            value: IKey;
            label: string;
        }[];
    };
    subSet: <T_11 = IKey>(arr1: T_11[], arr2: T_11[]) => T_11[];
    union: <T_12 = IKey>(arr1: T_12[], arr2: T_12[]) => T_12[];
    genMap: <T_13 extends IObj<any>>(map: T_13) => T_13;
    removeStr: (str: string, config: {
        removeStart?: string | undefined;
        removeEnd?: string | undefined;
    }) => string;
};
export default _default;
