import { IObj } from "../../type";
export declare type BFSOptions = {
    childrenStr?: string;
};
export declare type DFSOptions = {
    childrenStr?: string;
};
export interface TreeTransformOptions {
    idStr?: string;
    pidStr?: string;
    childrenStr?: string;
}
declare const _default: {
    bfsTree: <T = any>(tree: T[], cb: (item: T) => boolean | void, options?: BFSOptions) => void;
    dfsTree: <T_1 = any>(tree: T_1[], cb: (item: T_1) => boolean | void, options?: DFSOptions) => void;
    TreeTransform: {
        pid2children<T_2 = IObj<any>>(data: T_2[], options?: TreeTransformOptions): T_2[];
        children2pid<T_3 = IObj<any>>(data: T_3[], options?: TreeTransformOptions): any[];
    };
};
export default _default;
