import { DurationUnitsObjectType } from "dayjs/plugin/duration";
declare class StorageHelper implements Storage {
    private _prefix;
    private _storage;
    constructor(prefix: string, type?: "local" | "session");
    get length(): number;
    clear(): void;
    key(index: number): string | null;
    removeItem(key: string): void;
    getItem(key: string): any;
    setItem(key: string, value: any, _expire?: DurationUnitsObjectType | number): void;
}
export default StorageHelper;
